Index: /palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/flow_statistics.f90	(revision 2231)
+++ /palm/trunk/SOURCE/flow_statistics.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography and surface concept
 ! 
 ! Former revisions:
@@ -224,10 +224,8 @@
     USE arrays_3d,                                                             &
         ONLY:  ddzu, ddzw, e, heatflux_output_conversion, hyp, km, kh,         &
-               momentumflux_output_conversion, nr, ol, p, prho, prr, pt, q,    &
-               qc, ql, qr, qs, qsws, qswst, rho_air, rho_air_zw, rho_ocean, s, &
-               sa, ss, ssws, sswst, saswsb, saswst, shf, td_lsa_lpt, td_lsa_q, &
-               td_sub_lpt, td_sub_q, time_vert, ts, tswst, u, ug, us, usws,    &
-               uswst, vsws, v, vg, vpt, vswst, w, w_subs,                      &
-               waterflux_output_conversion, zw
+               momentumflux_output_conversion, nr, p, prho, prr, pt, q,        &
+               qc, ql, qr, rho_air, rho_air_zw, rho_ocean, s,                  &
+               sa, td_lsa_lpt, td_lsa_q, td_sub_lpt, td_sub_q, time_vert, u,   &
+               ug, v, vg, vpt, w, w_subs, waterflux_output_conversion, zw
         
     USE cloud_parameters,                                                      &
@@ -236,5 +234,5 @@
     USE control_parameters,                                                    &
         ONLY:   average_count_pr, cloud_droplets, cloud_physics, do_sum,       &
-                dt_3d, g, humidity, kappa, large_scale_forcing,                &
+                dt_3d, g, humidity, kappa, land_surface, large_scale_forcing,  &
                 large_scale_subsidence, max_pr_user, message_string, neutral,  &
                 microphysics_seifert, ocean, passive_scalar, simulated_time,   &
@@ -250,13 +248,10 @@
     USE indices,                                                               &
         ONLY:   ngp_2dh, ngp_2dh_s_inner, ngp_3d, ngp_3d_inner, ngp_sums,      &
-                ngp_sums_ls, nxl, nxr, nyn, nys, nzb, nzb_diff_s_inner,        &
-                nzb_s_inner, nzt, nzt_diff
+                ngp_sums_ls, nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
         
     USE kinds
     
     USE land_surface_model_mod,                                                &
-        ONLY:   ghf_eb, land_surface, m_soil, nzb_soil, nzt_soil,              &
-                qsws_eb, qsws_liq_eb, qsws_soil_eb, qsws_veg_eb, r_a, r_s,     &
-                shf_eb, t_soil
+        ONLY:   m_soil_h, nzb_soil, nzt_soil, t_soil_h
 
     USE netcdf_interface,                                                      &
@@ -277,4 +272,7 @@
     USE statistics
 
+       USE surface_mod,                                                        &
+          ONLY :  surf_def_h, surf_lsm_h, surf_usm_h
+
 
     IMPLICIT NONE
@@ -283,14 +281,18 @@
     INTEGER(iwp) ::  j                   !<
     INTEGER(iwp) ::  k                   !<
+    INTEGER(iwp) ::  ki                  !< 
     INTEGER(iwp) ::  k_surface_level     !<
+    INTEGER(iwp) ::  m                   !< loop variable over all horizontal wall elements 
+    INTEGER(iwp) ::  l                   !< loop variable over surface facing -- up- or downward-facing
     INTEGER(iwp) ::  nt                  !<
     INTEGER(iwp) ::  omp_get_thread_num  !<
     INTEGER(iwp) ::  sr                  !<
     INTEGER(iwp) ::  tn                  !<
-    
+
     LOGICAL ::  first  !<
     
     REAL(wp) ::  dptdz_threshold  !< 
     REAL(wp) ::  fac              !<
+    REAL(wp) ::  flag             !<
     REAL(wp) ::  height           !<
     REAL(wp) ::  pts              !<
@@ -400,15 +402,17 @@
 !--    for other horizontal averages.
        tn = 0
-
-       !$OMP PARALLEL PRIVATE( i, j, k, tn )
-!$     tn = omp_get_thread_num()
-
+       !$OMP PARALLEL PRIVATE( i, j, k, tn, flag )
+       !$ tn = omp_get_thread_num()
        !$OMP DO
        DO  i = nxl, nxr
           DO  j =  nys, nyn
-             DO  k = nzb_s_inner(j,i), nzt+1
-                sums_l(k,1,tn)  = sums_l(k,1,tn)  + u(k,j,i)  * rmask(j,i,sr)
-                sums_l(k,2,tn)  = sums_l(k,2,tn)  + v(k,j,i)  * rmask(j,i,sr)
-                sums_l(k,4,tn)  = sums_l(k,4,tn)  + pt(k,j,i) * rmask(j,i,sr)
+             DO  k = nzb, nzt+1
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 22 ) )
+                sums_l(k,1,tn)  = sums_l(k,1,tn)  + u(k,j,i)  * rmask(j,i,sr)  &
+                                                              * flag
+                sums_l(k,2,tn)  = sums_l(k,2,tn)  + v(k,j,i)  * rmask(j,i,sr)  &
+                                                              * flag
+                sums_l(k,4,tn)  = sums_l(k,4,tn)  + pt(k,j,i) * rmask(j,i,sr)  &
+                                                              * flag
              ENDDO
           ENDDO
@@ -421,7 +425,9 @@
           DO  i = nxl, nxr
              DO  j =  nys, nyn
-                DO  k = nzb_s_inner(j,i), nzt+1
-                   sums_l(k,23,tn)  = sums_l(k,23,tn) + &
-                                      sa(k,j,i) * rmask(j,i,sr)
+                DO  k = nzb, nzt+1
+                   sums_l(k,23,tn)  = sums_l(k,23,tn) + sa(k,j,i)              &
+                                    * rmask(j,i,sr)                            &
+                                    * MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 22 ) )
                 ENDDO
              ENDDO
@@ -437,9 +443,10 @@
           DO  i = nxl, nxr
              DO  j =  nys, nyn
-                DO  k = nzb_s_inner(j,i), nzt+1
-                   sums_l(k,44,tn)  = sums_l(k,44,tn) + &
-                                      vpt(k,j,i) * rmask(j,i,sr)
-                   sums_l(k,41,tn)  = sums_l(k,41,tn) + &
-                                      q(k,j,i) * rmask(j,i,sr)
+                DO  k = nzb, nzt+1
+                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 22 ) )
+                   sums_l(k,44,tn)  = sums_l(k,44,tn) +                        &
+                                      vpt(k,j,i) * rmask(j,i,sr) * flag
+                   sums_l(k,41,tn)  = sums_l(k,41,tn) +                        &
+                                      q(k,j,i) * rmask(j,i,sr)   * flag
                 ENDDO
              ENDDO
@@ -449,10 +456,13 @@
              DO  i = nxl, nxr
                 DO  j =  nys, nyn
-                   DO  k = nzb_s_inner(j,i), nzt+1
-                      sums_l(k,42,tn) = sums_l(k,42,tn) + &
-                                      ( q(k,j,i) - ql(k,j,i) ) * rmask(j,i,sr)
-                      sums_l(k,43,tn) = sums_l(k,43,tn) + ( &
+                   DO  k = nzb, nzt+1
+                      flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 22 ) )
+                      sums_l(k,42,tn) = sums_l(k,42,tn) +                      &
+                                      ( q(k,j,i) - ql(k,j,i) ) * rmask(j,i,sr) &
+                                                               * flag
+                      sums_l(k,43,tn) = sums_l(k,43,tn) + (                    &
                                       pt(k,j,i) + l_d_cp*pt_d_t(k) * ql(k,j,i) &
-                                                          ) * rmask(j,i,sr)
+                                                          ) * rmask(j,i,sr)    &
+                                                            * flag
                    ENDDO
                 ENDDO
@@ -467,6 +477,9 @@
           DO  i = nxl, nxr
              DO  j =  nys, nyn
-                DO  k = nzb_s_inner(j,i), nzt+1
-                   sums_l(k,117,tn)  = sums_l(k,117,tn) + s(k,j,i) * rmask(j,i,sr)
+                DO  k = nzb, nzt+1
+                   sums_l(k,117,tn)  = sums_l(k,117,tn) + s(k,j,i)             &
+                                    * rmask(j,i,sr)                            &
+                                    * MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 22 ) )
                 ENDDO
              ENDDO
@@ -603,39 +616,48 @@
        !$OMP PARALLEL PRIVATE( i, j, k, pts, sums_ll, sums_l_eper,             &
        !$OMP                   sums_l_etot, tn, ust, ust2, u2, vst, vst2, v2,  &
-       !$OMP                   w2 )
-!$     tn = omp_get_thread_num()
-
+       !$OMP                   w2, flag, m, ki, l )
+       !$ tn = omp_get_thread_num()
        !$OMP DO
        DO  i = nxl, nxr
           DO  j =  nys, nyn
              sums_l_etot = 0.0_wp
-             DO  k = nzb_s_inner(j,i), nzt+1
+             DO  k = nzb, nzt+1
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 22 ) )
 !
 !--             Prognostic and diagnostic variables
-                sums_l(k,3,tn)  = sums_l(k,3,tn)  + w(k,j,i)  * rmask(j,i,sr)
-                sums_l(k,8,tn)  = sums_l(k,8,tn)  + e(k,j,i)  * rmask(j,i,sr)
-                sums_l(k,9,tn)  = sums_l(k,9,tn)  + km(k,j,i) * rmask(j,i,sr)
-                sums_l(k,10,tn) = sums_l(k,10,tn) + kh(k,j,i) * rmask(j,i,sr)
-                sums_l(k,40,tn) = sums_l(k,40,tn) + p(k,j,i)
+                sums_l(k,3,tn)  = sums_l(k,3,tn)  + w(k,j,i)  * rmask(j,i,sr)  &
+                                                              * flag
+                sums_l(k,8,tn)  = sums_l(k,8,tn)  + e(k,j,i)  * rmask(j,i,sr)  &
+                                                              * flag
+                sums_l(k,9,tn)  = sums_l(k,9,tn)  + km(k,j,i) * rmask(j,i,sr)  &
+                                                              * flag
+                sums_l(k,10,tn) = sums_l(k,10,tn) + kh(k,j,i) * rmask(j,i,sr)  &
+                                                              * flag
+                sums_l(k,40,tn) = sums_l(k,40,tn) + p(k,j,i)  * flag
 
                 sums_l(k,33,tn) = sums_l(k,33,tn) + &
-                                  ( pt(k,j,i)-hom(k,1,4,sr) )**2 * rmask(j,i,sr)
+                                  ( pt(k,j,i)-hom(k,1,4,sr) )**2 * rmask(j,i,sr)&
+                                                                 * flag
 
                 IF ( humidity )  THEN
                    sums_l(k,70,tn) = sums_l(k,70,tn) + &
-                                  ( q(k,j,i)-hom(k,1,41,sr) )**2 * rmask(j,i,sr)
+                                  ( q(k,j,i)-hom(k,1,41,sr) )**2 * rmask(j,i,sr)&
+                                                                 * flag
                 ENDIF
                 IF ( passive_scalar )  THEN
                    sums_l(k,118,tn) = sums_l(k,118,tn) + &
-                                  ( s(k,j,i)-hom(k,1,117,sr) )**2 * rmask(j,i,sr)
+                                  ( s(k,j,i)-hom(k,1,117,sr) )**2 * rmask(j,i,sr)&
+                                                                  * flag
                 ENDIF
 !
 !--             Higher moments
 !--             (Computation of the skewness of w further below)
-                sums_l(k,38,tn) = sums_l(k,38,tn) + w(k,j,i)**3 * rmask(j,i,sr)
+                sums_l(k,38,tn) = sums_l(k,38,tn) + w(k,j,i)**3 * rmask(j,i,sr) &
+                                                                * flag
 
                 sums_l_etot  = sums_l_etot + &
-                                        0.5_wp * ( u(k,j,i)**2 + v(k,j,i)**2 + &
-                                        w(k,j,i)**2 ) * rmask(j,i,sr)
+                                        0.5_wp * ( u(k,j,i)**2 + v(k,j,i)**2 +  &
+                                        w(k,j,i)**2 )            * rmask(j,i,sr)&
+                                                                 * flag
              ENDDO
 !
@@ -647,19 +669,60 @@
 !
 !--          2D-arrays (being collected in the last column of sums_l)
-             sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +               &
-                                        us(j,i)   * rmask(j,i,sr)
-             sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +             &
-                                        usws(j,i) * rmask(j,i,sr)
-             sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +             &
-                                        vsws(j,i) * rmask(j,i,sr)
-             sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +             &
-                                        ts(j,i)   * rmask(j,i,sr)
-             IF ( humidity )  THEN
-                sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +        &
-                                            qs(j,i)   * rmask(j,i,sr)
+             IF ( surf_def_h(0)%ns >= 1 )  THEN
+                m = surf_def_h(0)%start_index(j,i)
+                sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +               &
+                                        surf_def_h(0)%us(m)   * rmask(j,i,sr)
+                sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +             &
+                                        surf_def_h(0)%usws(m) * rmask(j,i,sr)
+                sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +             &
+                                        surf_def_h(0)%vsws(m) * rmask(j,i,sr)
+                sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +             &
+                                        surf_def_h(0)%ts(m)   * rmask(j,i,sr)
+                IF ( humidity )  THEN
+                   sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +        &
+                                            surf_def_h(0)%qs(m)   * rmask(j,i,sr)
+                ENDIF
+                IF ( passive_scalar )  THEN
+                   sums_l(nzb+13,pr_palm,tn) = sums_l(nzb+13,pr_palm,tn) +        &
+                                            surf_def_h(0)%ss(m)   * rmask(j,i,sr)
+                ENDIF
              ENDIF
-             IF ( passive_scalar )  THEN
-                sums_l(nzb+13,pr_palm,tn) = sums_l(nzb+13,pr_palm,tn) +        &
-                                            ss(j,i)   * rmask(j,i,sr)
+             IF ( surf_lsm_h%ns >= 1 )  THEN
+                m = surf_lsm_h%start_index(j,i)
+                sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +               &
+                                        surf_lsm_h%us(m)   * rmask(j,i,sr)
+                sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +             &
+                                        surf_lsm_h%usws(m) * rmask(j,i,sr)
+                sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +             &
+                                        surf_lsm_h%vsws(m) * rmask(j,i,sr)
+                sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +             &
+                                        surf_lsm_h%ts(m)   * rmask(j,i,sr)
+                IF ( humidity )  THEN
+                   sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +        &
+                                            surf_lsm_h%qs(m)   * rmask(j,i,sr)
+                ENDIF
+                IF ( passive_scalar )  THEN
+                   sums_l(nzb+13,pr_palm,tn) = sums_l(nzb+13,pr_palm,tn) +        &
+                                            surf_lsm_h%ss(m)   * rmask(j,i,sr)
+                ENDIF
+             ENDIF
+             IF ( surf_usm_h%ns >= 1 )  THEN
+                m = surf_lsm_h%start_index(j,i)
+                sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +               &
+                                        surf_usm_h%us(m)   * rmask(j,i,sr)
+                sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +             &
+                                        surf_usm_h%usws(m) * rmask(j,i,sr)
+                sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +             &
+                                        surf_usm_h%vsws(m) * rmask(j,i,sr)
+                sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +             &
+                                        surf_usm_h%ts(m)   * rmask(j,i,sr)
+                IF ( humidity )  THEN
+                   sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +        &
+                                            surf_usm_h%qs(m)   * rmask(j,i,sr)
+                ENDIF
+                IF ( passive_scalar )  THEN
+                   sums_l(nzb+13,pr_palm,tn) = sums_l(nzb+13,pr_palm,tn) +        &
+                                            surf_usm_h%ss(m)   * rmask(j,i,sr)
+                ENDIF
              ENDIF
           ENDDO
@@ -674,5 +737,7 @@
           DO  i = nxl, nxr
              DO  j =  nys, nyn
-                DO  k = nzb_s_inner(j,i), nzt+1
+                DO  k = nzb, nzt+1
+                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 22 ) )
+
                    u2   = u(k,j,i)**2
                    v2   = v(k,j,i)**2
@@ -681,12 +746,16 @@
                    vst2 = ( v(k,j,i) - hom(k,1,2,sr) )**2
 
-                   sums_l(k,30,tn) = sums_l(k,30,tn) + ust2 * rmask(j,i,sr)
-                   sums_l(k,31,tn) = sums_l(k,31,tn) + vst2 * rmask(j,i,sr)
-                   sums_l(k,32,tn) = sums_l(k,32,tn) + w2   * rmask(j,i,sr)
+                   sums_l(k,30,tn) = sums_l(k,30,tn) + ust2 * rmask(j,i,sr)    &
+                                                            * flag
+                   sums_l(k,31,tn) = sums_l(k,31,tn) + vst2 * rmask(j,i,sr)    &
+                                                            * flag
+                   sums_l(k,32,tn) = sums_l(k,32,tn) + w2   * rmask(j,i,sr)    &
+                                                            * flag
 !
 !--                Perturbation energy
 
                    sums_l(k,34,tn) = sums_l(k,34,tn) + 0.5_wp *                &
-                                  ( ust2 + vst2 + w2 ) * rmask(j,i,sr)
+                                  ( ust2 + vst2 + w2 )      * rmask(j,i,sr)    &
+                                                            * flag
                 ENDDO
              ENDDO
@@ -702,5 +771,7 @@
        DO  i = nxl, nxr
           DO  j =  nys, nyn
-             DO  k = nzb_s_inner(j,i), nzt+1
+             DO  k = nzb, nzt+1
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 22 ) )
+
                 w2   = w(k,j,i)**2
                 ust2 = ( u(k,j,i) - hom(k,1,1,sr) )**2
@@ -709,5 +780,7 @@
 
                 sums_l(nzb+5,pr_palm,tn) = sums_l(nzb+5,pr_palm,tn)            &
-                                 + 0.5_wp * ( ust2 + vst2 + w2 ) * rmask(j,i,sr)
+                                 + 0.5_wp * ( ust2 + vst2 + w2 )               &
+                                 * rmask(j,i,sr)                               &
+                                 * flag
              ENDDO
           ENDDO
@@ -728,6 +801,11 @@
 !--                However, this implies no error since staggered velocity 
 !--                components are zero at the walls and inside buildings.
-
-             DO  k = nzb_diff_s_inner(j,i)-1, nzt_diff
+!--          Flag 23 is used to mask surface fluxes as well as model-top fluxes,
+!--          which are added further below. 
+             DO  k = nzb, nzt
+                flag = MERGE( 1.0_wp, 0.0_wp,                                  &
+                              BTEST( wall_flags_0(k,j,i), 23 ) ) *             &
+                       MERGE( 1.0_wp, 0.0_wp,                                  &
+                              BTEST( wall_flags_0(k,j,i), 9  ) )
 !
 !--             Momentum flux w"u"
@@ -739,5 +817,6 @@
                                                            ) * rmask(j,i,sr)   &
                                          * rho_air_zw(k)                       &
-                                         * momentumflux_output_conversion(k)
+                                         * momentumflux_output_conversion(k)   &
+                                         * flag
 !
 !--             Momentum flux w"v"
@@ -749,5 +828,6 @@
                                                            ) * rmask(j,i,sr)   &
                                          * rho_air_zw(k)                       &
-                                         * momentumflux_output_conversion(k)
+                                         * momentumflux_output_conversion(k)   &
+                                         * flag
 !
 !--             Heat flux w"pt"
@@ -757,5 +837,6 @@
                                                * rho_air_zw(k)                 &
                                                * heatflux_output_conversion(k) &
-                                               * ddzu(k+1) * rmask(j,i,sr)
+                                               * ddzu(k+1) * rmask(j,i,sr)     &
+                                               * flag
 
 
@@ -766,5 +847,6 @@
                                          - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )&
                                                * ( sa(k+1,j,i) - sa(k,j,i) )   &
-                                               * ddzu(k+1) * rmask(j,i,sr)
+                                               * ddzu(k+1) * rmask(j,i,sr)     &
+                                               * flag
                 ENDIF
 
@@ -777,5 +859,5 @@
                                                * rho_air_zw(k)                 &
                                                * heatflux_output_conversion(k) &
-                                               * ddzu(k+1) * rmask(j,i,sr)
+                                               * ddzu(k+1) * rmask(j,i,sr) * flag
                    sums_l(k,48,tn) = sums_l(k,48,tn)                           &
                                          - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )&
@@ -783,5 +865,5 @@
                                                * rho_air_zw(k)                 &
                                                * waterflux_output_conversion(k)&
-                                               * ddzu(k+1) * rmask(j,i,sr)
+                                               * ddzu(k+1) * rmask(j,i,sr) * flag
 
                    IF ( cloud_physics ) THEN
@@ -792,5 +874,5 @@
                                                * rho_air_zw(k)                 &
                                                * waterflux_output_conversion(k)&
-                                               * ddzu(k+1) * rmask(j,i,sr) 
+                                               * ddzu(k+1) * rmask(j,i,sr) * flag
                    ENDIF
                 ENDIF
@@ -802,5 +884,6 @@
                                          - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )&
                                                   * ( s(k+1,j,i) - s(k,j,i) )  &
-                                                  * ddzu(k+1) * rmask(j,i,sr)
+                                                  * ddzu(k+1) * rmask(j,i,sr)  &
+                                                              * flag
                 ENDIF
 
